package com.hikari.regedist.support;

public class BusinessError extends RuntimeException {

    public static final int SUCCESS = 0;
    public static final int VALIDATE_FAILD = -1;
    public static final int INSERT_DATA_ALLREADY_EXIST = -2;
    public static final int DATA_NOT_EXIST = -3;
    public static final int DATA_NOT_ILLEGAL = -4;
    public static final int DEL_DATA_HASCHILDREN = -5;
    public static final int UNKNOWN_ERROR = -10000;

    protected int errCode;
    protected String errMsg;
    protected String details;

    public BusinessError(int errCode) {
        super(getErrDetails(errCode));
        this.errCode = errCode;
        this.errMsg = getErrDetails(errCode);
        this.details = this.errMsg;
    }

    public BusinessError(int errCode, String errMsg) {
        super(errMsg);
        this.errMsg = errMsg;
        this.errCode = errCode;
        this.details = this.errMsg;
    }

    public BusinessError(int errCode, String errMsg, String details) {
        super(errMsg);
        this.errCode = errCode;
        this.errMsg = errMsg;
        this.details = details;
    }

    public static String getErrDetails(int errCode) {
        switch (errCode) {
            case SUCCESS:
                return "操作成功";
            case VALIDATE_FAILD:
                return "数据校验失败";
            case INSERT_DATA_ALLREADY_EXIST:
                return "数据已存在";
            case DATA_NOT_EXIST:
                return "数据不存在";
            case DATA_NOT_ILLEGAL:
                return "参数不合法";
            case DEL_DATA_HASCHILDREN:
                return "被删除项含有子项，无法删除";
            default:
                return "未知错误";
        }
    }

    public int getErrcode() {
        return errCode;
    }

    public String getErrmsg() {
        if (this.errMsg == null) return this.getMessage();
        return this.errMsg;
    }

    public String getDetails() {
        return details;
    }
}
