package com.hikari.regedist

import org.springframework.boot.context.properties.ConfigurationProperties

@ConfigurationProperties(prefix = "hikari.policy")
class PolicyConfiguration {

    var separator: String = "/"

    /**
     * 策略删除策略
     * soft：被删除的策略含有子项时，无法删除
     * hard: 删除策略本身及所有子项
     */
    var deletePolicy: String? = "soft"

    /**
     * 是否级联删除策略下所有策略项，true：删除策略时删除策略所属的所有策略项，false：被删除策略
     */
    var cascadeDelPolicyItem: Boolean = false
}