package com.hikari.regedist

import com.hikari.regedist.domain.PolicyForm
import com.hikari.regedist.domain.PolicyResult
import com.hikari.regedist.entity.Policy
import com.hikari.regedist.service.PolicyService
import gaf3.core.data.PageParam
import gaf3.core.data.PagedData
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.web.bind.annotation.*

@RestController
class PolicyController {

    @Autowired
    lateinit var policyService: PolicyService

    @PostMapping(path = ["/policy"])
    fun create(@RequestBody form: PolicyForm): Policy {
        return policyService.create(form)
    }

    @PostMapping(path = ["/policy/{id}"])
    fun update(@PathVariable id: String, @RequestBody form: PolicyForm): Policy {
        return policyService.update(id, form)
    }

    @GetMapping(path = ["/policy"])
    fun find(filter: Policy, pageParam: PageParam): PagedData<Policy> {
        return policyService.find(filter, pageParam)
    }

    @GetMapping(path = ["/policy/{id}"])
    fun findById(@PathVariable id: String): Policy {
        return policyService.findById(id)
    }

    @DeleteMapping(path = ["/policy/{id}"])
    fun delete(@PathVariable id: String) {
        return policyService.delete(id)
    }

}