package com.hikari.regedist

import com.hikari.regedist.domain.PolicyItemForm
import com.hikari.regedist.entity.PolicyItem
import com.hikari.regedist.service.PolicyItemService
import gaf3.core.data.PageParam
import gaf3.core.data.PagedData
import kotlinx.coroutines.DisposableHandle
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.web.bind.annotation.*

@RestController
class PolicyItemController {

    @Autowired
    lateinit var policyItemService: PolicyItemService

    @PostMapping(path = ["/policyItem"])
    fun create(@RequestBody form: PolicyItemForm): PolicyItem {
        return policyItemService.create(form)
    }

    @PostMapping(path = ["/policyItem/{id}"])
    fun update(@PathVariable id: String, @RequestBody form: PolicyItemForm): PolicyItem {
        return policyItemService.update(id, form)
    }

    @GetMapping(path = ["/policyItem"])
    fun find(filter: PolicyItem, pageParam: PageParam): PagedData<PolicyItem> {
        return policyItemService.find(filter, pageParam)
    }

    @GetMapping(path = ["/policyItem/{id}"])
    fun findById(@PathVariable id: String): PolicyItem {
        return policyItemService.findById(id)
    }

    @DeleteMapping(path = ["/policyItem/{id}"])
    fun delete(@PathVariable id: String) {
        policyItemService.delete(id)
    }

}