package com.hikari.regedist.dao

import com.hikari.regedist.entity.Policy
import org.springframework.data.jpa.repository.JpaRepository
import org.springframework.data.jpa.repository.JpaSpecificationExecutor

interface PolicyDao : JpaRepository<Policy, String>, JpaSpecificationExecutor<Policy> {

    fun findByName(name: String): Policy?

    fun findByNameAndParentId(name: String, parentId: String): Policy?

    fun findByPolicyKeyAndParentId(name: String, parentId: String): Policy?

    fun findByNameAndParentIdIsNull(name: String): Policy?

    fun findByPolicyKeyAndParentIdIsNull(name: String): Policy?

    fun existsByParentId(pid: String): Boolean

}